package com.bcxin.security.domains.entities;

import com.bcxin.Infrastructures.entities.EntityAbstract;
import com.bcxin.Infrastructures.entities.IAggregate;
import com.bcxin.Infrastructures.enums.CredentialType;
import com.bcxin.Infrastructures.enums.OccupationType;
import com.bcxin.Infrastructures.utils.UUIDUtil;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.sql.Timestamp;
import java.time.Instant;

@Getter
@Setter
@Table(name = "tlk_attendance_site_arrange_info")
@Entity
public class AttendSiteArrangeEntity extends EntityAbstract implements IAggregate {

    @Id
    private String id;

    @Column(name = "ITEM_SECURITYNAME")
    private String securityName;

    @Column(name = "ITEM_SECURITYID")
    private String securityId;

    @Column(name = "ITEM_ATTENDANCESITEID")
    private String attendanceSiteId;

    @Column(name = "ITEM_DOCUMENTTYPE")
    @Enumerated(EnumType.ORDINAL)
    private CredentialType documentType;

    @Column(name = "ITEM_DOCUMENTID")
    private String documentId;

    @Column(name = "ITEM_PHONE")
    private String phone;

    @Column(name = "ITEM_JOIN_ATT_TIME")
    private Timestamp joinAttTime;

    @Column(name = "ITEM_JOIN_ATT_OPERATOR")
    private String joinAttOperator;

    @Column(name = "ITEM_LEAVE_ATT_TIME")
    private Timestamp leaveAttTime;

    @Column(name = "ITEM_LEAVE_ATT_OPERATOR")
    private String leaveAttOperator;


    @Column(name = "DOMAINID")
    private String domainId;

    @Column(name = "AUTHOR")
    private String author;

    @Column(name = "AUTHORDEPTID")
    private String authorDeptId;

    @Column(name = "AUTHOR_DEPT_INDEX")
    private String authorDeptIndex;

    @Column(name = "LASTMODIFIER")
    private String lastModifier;

    @Column(name = "CREATED")
    private Timestamp created;

    @Column(name = "LASTMODIFIED")
    private Timestamp lastModified;

    @Column(name = "APPLICATIONID")
    private String applicationId;

    @Column(name = "FORMID")
    private String formId;

    @Column(name = "FORMNAME")
    private String formName;

    @Column(name = "ISTMP")
    private boolean isTmp = false;

    @Column(name = "STATEINT")
    private String stateint = "0";

    public AttendSiteArrangeEntity(){}

    public AttendSiteArrangeEntity(String securityName,
                                   String securityId,
                                   CredentialType documentType,
                                   String documentId,
                                   String phone,
                                   Timestamp joinAttTime,
                                   String joinAttOperator,
                                   Timestamp leaveAttTime,
                                   String leaveAttOperator,
                                   String attendanceSiteId,
                                   String domainId,
                                   String author,
                                   String authorDeptId,
                                   String authorDeptIndex,
                                   String lastModifier,
                                   String applicationId,
                                   String formId,
                                   String formName
                                  ){
        this.securityName = securityName;
        this.securityId = securityId;
        this.documentType = documentType;
        this.documentId = documentId;
        this.phone = phone;
        this.joinAttTime=joinAttTime;
        this.joinAttOperator=joinAttOperator;
        this.leaveAttTime=leaveAttTime;
        this.leaveAttOperator=leaveAttOperator;
        this.attendanceSiteId = attendanceSiteId;
        this.domainId = domainId;
        this.author = author;
        this.authorDeptId = authorDeptId;
        this.authorDeptIndex = authorDeptIndex;
        this.lastModifier = lastModifier;
        this.applicationId = applicationId;
        this.formId = formId;
        this.formName = formName;

    }

    public static AttendSiteArrangeEntity create(String securityName,
                                                 String securityId,
                                                 CredentialType documentType,
                                                 String documentId,
                                                 String phone,
                                                 Timestamp joinAttTime,
                                                 String joinAttOperator,
                                                 Timestamp leaveAttTime,
                                                 String leaveAttOperator,
                                                 String attendanceSiteId,
                                                 String domainId,
                                                 String author,
                                                 String authorDeptId,
                                                 String authorDeptIndex,
                                                 String lastModifier,
                                                 String applicationId,
                                                 String formId,
                                                 String formName) {
        AttendSiteArrangeEntity attendSitePerson = new AttendSiteArrangeEntity(securityName,
                securityId,
                documentType,
                documentId,
                phone,
               joinAttTime,joinAttOperator,leaveAttTime,leaveAttOperator,
                attendanceSiteId,
                domainId,
                author,
                authorDeptId,
                authorDeptIndex,
                lastModifier,
                applicationId,
                formId,
                formName);
        attendSitePerson.setId(UUIDUtil.getShortUuid()+"--"+formId);
        attendSitePerson.setCreated(Timestamp.from(Instant.now()));
        attendSitePerson.setLastModified(Timestamp.from(Instant.now()));
        return attendSitePerson;
    }
}
